default_font_name = "Segoe UI";
min_stripe_width = 256;
vol_max = 20;
snap_gap = 10;
gesture_insensitivity = 10;
gesture_angle_parameter = 3;
playlist_scroll_step = 1;
temp_display_delay = 1500;
paused_blink = true;
paused_blink_delay = 500;
paused_blink_opacity = 192;
prog_temp = 0;
slider_on_bottom = false;
display_playing = false;
display_paused = false;
if (foobar.get_volume () < -2000) then
vol_max = -foobar.get_volume();
end
function option (key, defvalue, show, list)
local value = config.load (defvalue, key);
config.save (value, key, show, list);
return value;
end
skin = option ("Skin:", 'Original', true, {'Original', 'Snow', 'Indigo', 'Glamour', 'Hamburger'});
skin_file = 'birman-skin-' .. skin .. ".bmp";
skin_bitmap = bitmap.new (skin_file);
o_wheel_action_seek = 'Seek';
o_wheel_action_volume = 'Adjust volume';
o_wheel_action_prev_next = 'Previous / Next';
o_wheel_action_none = 'Ignore';
o_ldbl_action_pause = 'Play / Pause';
o_ldbl_action_playlist = 'Show / Hide playlist';
o_ldbl_action_menu = 'Show main menu';
o_ldbl_action_none = 'Ignore';
o_ldbl_action = option ("Doubleclick action:", o_ldbl_action_pause, true, {o_ldbl_action_pause, o_ldbl_action_playlist, o_ldbl_action_menu, o_ldbl_action_none});
o_wheel_action = option ("Wheel press-and-rotate action:", o_wheel_action_seek, true, {o_wheel_action_seek, o_wheel_action_volume, o_wheel_action_prev_next, o_wheel_action_none});
wheel_position_change = option ('if Seek, how many seconds per step:', '5', true, {'5', '10', '15', '30', '60'});
wheel_volume_change = option ('if Adjust volume, how much per step:', '20', true, {'2', '5', '10', '20'});
volume_change = option ("Usual wheel volume change:", '2');
r_position_change = option ("Wheel-seek with right button, seconds:", '5', true, {'5', '10', '15', '30', '60'});
o_m_pause = option ("Play / Pause on Wheel press?", false, true);
o_r_pause = option ("or on right button within slider?", false, true);
o_gestures = true;
main_font = option ("Player stripe font", font.new (default_font_name, 11, 0, 1000))
pl_font = option ("Playlist font", font.new (default_font_name, 14, 0, 400))
title_format = option (
"Left-aligned text content (use Tagz)",
"[%artist% $char(8212) ]%title%", true,
{
"[%artist% $char(8212) ]%title%",
"[%artist% $char(8212) ]%title%[ '('%album%[, %date%]')']"
}
);
title_color = skin_bitmap:get_pixel (26, 6);
--title_color = color.new (255, 255, 255);
time_format = option (
"Right-aligned text content (use Tagz)",
"%_time_elapsed%   $char(8211)%_time_remaining%   %_length%", true,
{
"%_time_elapsed%   $char(8211)%_time_remaining%   %_length%",
"+%_time_elapsed% '('$char(8211)%_time_remaining%')' of %_length%",
"%_time_elapsed% $char(8211)%_time_remaining%",
"%_time_elapsed%",
"$char(8211)%_time_remaining%",
}
);
time_color = skin_bitmap:get_pixel (36, 6);
p_all = rect.new (-9999, -9999, 9999, 9999);
function update_textfield_sizes ()
time_rect = time_field:get_pos ();
if (time_rect.width ~= time_field:getTextWidth ()) then
time_new_width = time_field:getTextWidth ();
win_pos = win_stripe:get_pos ();
time_place_new = rect.new (win_pos.width-time_new_width - 4, 1, win_pos.width - 4, 18); -- rect.new (-time_width-4, 1, -4, 18);
time_field:set_pos (time_place_new);
title_place_new = rect.new (6, 1, win_pos.width-time_new_width-18, 18); -- rect.new (6, 1, -time_width-2-27, 18);
title_field:set_pos (title_place_new);
end
end
function w1_update()
slider.pos = foobar.time_elapsed ();
slider:redraw ();
title_field:update ();
time_field:update ();
update_textfield_sizes ();
end
function w1_newTrack()
slider.max = foobar.title_playtime ();
w1_update ();
end
function next_track ()
foobar.next ();
end
function prev_track ()
foobar.prev ();
end
function playlist_showhide ()
if (win_playlist:is_visible ())
then win_playlist:close ();
else win_playlist:create ();
end
end
win_stripe = window.new ("ui", min_stripe_width, 18, rect.new (0, 0, min_stripe_width, 18), 3);
stripe_place = rect.new (0, 0, 2560, 18)
stripe_image = image.new (skin_bitmap, rect.new_size (6, 0, 18, 18));
win_stripe:add_paint_part (stripe_place, stripe_image);
win_stripe:set_add_file_option (2);
size_grip_place = rect.new_size (0, 3, 6, 12);
size_grip_actual_place = rect.new_size (2, 6, 1, 7);
size_grip_image = image.new (skin_bitmap, rect.new_size (2, 6, 1, 7));
win_stripe:add (size_grip_place);
win_stripe:add_paint_part (size_grip_actual_place, size_grip_image);
win_stripe:add_part_callback ("LDown", size_grip_place, function () win_stripe:resize (0); end);
time_width = 0;
title_place = rect.new (6, 1, -time_width-2-27, 18);
title_field = textfield.new (title_place, title_format, 0, main_font, title_color, false);
win_stripe:add (title_place);
win_stripe:add (title_field);
time_place = rect.new (-time_width-4, 1, -4, 18);
time_field = textfield.new (time_place, time_format, 0, main_font, time_color, true);
win_stripe:add (time_place);
win_stripe:add (time_field);
update_textfield_sizes ();
temp_display_timer = timer.new (
function () 
time_field:set_text (time_format);
temp_display_timer:stop ();
update_textfield_sizes ()
end
)
if (slider_on_bottom == false) then
slider_place = rect.new (0, 0, 0, 4);
else
slider_place = rect.new (0, 14, 0, 4);
end
slider_image = image.new (skin_bitmap, rect.new_size (24, 0, 22, 4));
slider = progbar.new (slider_place, slider_image, 
0,
function () prog_temp = slider.pos; end,
function () foobar.seek (slider.pos); end
);
slider.pos = foobar.time_elapsed ();
if (foobar.is_playing () == 1)
then slider.show = true;
else slider.show = false;
end
slider.enabled = slider.show;
win_stripe:add (slider_place);
win_stripe:add (slider);
win_stripe:add_part_callback ("RDown", p_all,
function ()
if (slider.sliding == true) then
slider.pos = prog_temp;
foobar.seek (prog_temp);
slider.sliding = false;
time_field:update();
end
end
);
nonslider_place = rect.new (0, 4, 0, 18);
win_stripe:add (nonslider_place);
win_stripe:add_part_callback ("LDbl", nonslider_place,
function ()
if o_ldbl_action == o_ldbl_action_pause or window.isKeyDown ('shift') then
foobar.pause ();
elseif o_ldbl_action == o_ldbl_action_playlist or window.isKeyDown ('control') then
if (win_playlist:is_visible ())
then win_playlist:close ();
else win_playlist:create ();
end
elseif o_ldbl_action == o_ldbl_action_menu then
foobar.show_main_menu(); 
end
end
);
r_press_pos = 0;
r_release_pos = 0;
l_pressed = false;
wheel_pressed = false;
r_pressed = false;
rotated = false;
it_was_menu = false;
win_stripe:add_part_callback ("MDown", p_all, function () wheel_pressed = true; end );
win_stripe:add_part_callback ("MUp", p_all,
function ()
wheel_pressed = false;
if (o_m_pause and not rotated) then foobar.pause (); end
rotated = false;
end
);
win_stripe:add_part_callback ("RDown", p_all,
function ()
local x = window.get_mouse_pos ().x - win_stripe:get_pos ().left;
local y = window.get_mouse_pos ().y - win_stripe:get_pos ().top;
r_pressed = true;
r_press_pos_x = x;
r_press_pos_y = y;
if (slider_on_bottom == false) then
r_pressed_in_slider = (y <= 4);
else
r_pressed_in_slider = (y >= 14);
end
end );
win_stripe:add_part_callback ("RUp", p_all,
function ()
r_pressed = false;
if (not rotated) then
local x = window.get_mouse_pos ().x - win_stripe:get_pos ().left;
local y = window.get_mouse_pos ().y - win_stripe:get_pos ().top;
r_motion_x = x - r_press_pos_x;
r_motion_y = y - r_press_pos_y;
r_motion = math.sqrt (r_motion_x*r_motion_x + r_motion_y*r_motion_y);
gesture = o_gestures and (r_motion > gesture_insensitivity);
gesture_left = (r_motion_x < 0) and (math.abs (r_motion_x) > math.abs (r_motion_y) * gesture_angle_parameter);
gesture_right = (r_motion_x > 0) and (math.abs (r_motion_x) > math.abs (r_motion_y) * gesture_angle_parameter);
gesture_down = (r_motion_y > 0) and (math.abs (r_motion_y) > math.abs (r_motion_x) * gesture_angle_parameter);
if gesture and gesture_right then next_track ()
elseif gesture and gesture_left then prev_track ()
elseif gesture and gesture_down then playlist_showhide ();
elseif r_pressed_in_slider and o_r_pause then foobar.pause (); 
elseif foobar.is_playing () and window.isKeyDown ('shift') then foobar.show_main_menu ();
elseif foobar.is_playing () then foobar.show_context_menu ();
else foobar.show_main_menu (); end
end
rotated = false;
r_press_pos = 0;
end
);
function wheel_action_perform (dir)
rotated = true;
temp_volume_change = volume_change;
temp_wheel_volume_change = wheel_volume_change;
temp_wheel_position_change = wheel_position_change;
temp_r_position_change = r_position_change;
if window.isKeyDown ('shift') then 
temp_volume_change = 1;
temp_wheel_volume_change = 1;
temp_wheel_position_change = 1;
temp_r_position_change = 1;
end
if window.isKeyDown ('control') then 
temp_volume_change = volume_change * 2;
temp_wheel_volume_change = wheel_volume_change * 2;
temp_wheel_position_change = wheel_position_change * 10;
temp_r_position_change = r_position_change * 10;
end
if (wheel_pressed) then
if (o_wheel_action == o_wheel_action_prev_next) then
if (dir == 1) then foobar.next (); else foobar.prev (); end
elseif (o_wheel_action == o_wheel_action_seek) then
foobar.seek (foobar.time_elapsed () + temp_wheel_position_change * dir);
elseif (o_wheel_action == o_wheel_action_volume) then
foobar.set_volume (foobar.get_volume () + temp_wheel_volume_change * dir);
end
elseif (r_pressed) then 
foobar.seek (foobar.time_elapsed () + temp_r_position_change * dir);
else
foobar.set_volume (foobar.get_volume () + temp_volume_change * dir);
end;
end
win_stripe:set_callback ("OnWheelUp", function () wheel_action_perform (1); end);
win_stripe:set_callback ("OnWheelDown", function () wheel_action_perform (-1); end);
win_stripe:add_part_callback ("LDown", slider_place,
function ()
if (foobar.is_playing () == 0) then
foobar.play ();
slider.pos = prog_temp;
foobar.seek (prog_temp);
time_field:update ();
end
end
);
win_stripe:set_callback ("OnShow",
function ()
set_global_callback ("OnTime", w1_update);
set_global_callback ("OnSeek", w1_update);
set_global_callback ("OnNewTrack", w1_newTrack);
w1_newTrack();
end
);
win_stripe:set_callback ("OnClose", foobar.quit);
win_playlist = window.new ("pl", min_stripe_width, 100, rect.new (0, 0, min_stripe_width, 100), 3);
win_playlist:add (p_all);
grad_top_place = rect.new (0, 0, 2560, 18);
grad_top_image = image.new (skin_bitmap, rect.new_size (6, 18, 18, 18));
win_playlist:add_paint_part (grad_top_place, grad_top_image);
the_playlist_border_color = skin_bitmap:get_pixel (0, 18);
the_playlist_bg_color = skin_bitmap:get_pixel (1, 18);
the_playlist_bg_place = color_rect.new (rect.new (0, 18, 2560, 0), the_playlist_bg_color);
win_playlist:add (the_playlist_bg_place);
the_playlist_top_place = color_rect.new (rect.new (0, 0, 2560, 1), the_playlist_border_color);
win_playlist:add (the_playlist_top_place);
the_playlist_left_place = color_rect.new (rect.new (0, 0, 1, -0), the_playlist_border_color);
win_playlist:add (the_playlist_left_place);
the_playlist_right_place = color_rect.new (rect.new (-1, 0, -0, -0), the_playlist_border_color);
win_playlist:add (the_playlist_right_place);
the_playlist_bottom_place = color_rect.new (rect.new (0, -1, 2560, 0), the_playlist_border_color);
win_playlist:add (the_playlist_bottom_place);
the_playlist_bg_place_2 = color_rect.new (rect.new (17, 17, -17, -17), the_playlist_border_color);
win_playlist:add (the_playlist_bg_place_2);
x_bg_place = rect.new (-18, 1, -1, 18);
x_bg = color_rect.new (x_bg_place, the_playlist_bg_color);
x_itself_place = rect.new (-14, 6, -6, 14);
x_itself = color_rect.new (x_itself_place, color.new (0, 0, 0));
win_playlist:add (x_bg_place);
win_playlist:add (x_bg);
win_playlist:add (x_itself);
x_place = rect.new (-19, 0, -6, 19);
win_playlist:add_part_callback ("LDown", x_bg_place, playlist_showhide);
the_playlist_place = rect.new (18, 18, -18, -18);
pl_bg_color = skin_bitmap:get_pixel (6, 36);
pl_focus_color = skin_bitmap:get_pixel (8, 38);
pl_bg_color_sel = skin_bitmap:get_pixel (8, 38);
pl_text_color = skin_bitmap:get_pixel (10, 40);
the_playlist = playlist.new (the_playlist_place, pl_font, pl_text_color, pl_bg_color, pl_bg_color_sel, pl_focus_color,
function () 
if (w3_scrollbar.sliding == false) then 
w3_scrollbar.pos = the_playlist:get_pos();
end
end
);
win_playlist:add (the_playlist);
the_playlist_bottom_place_2 = color_rect.new (rect.new (1, -18, -1, -1), the_playlist_bg_color);
win_playlist:add (the_playlist_bottom_place_2);
function w3_check_scrollable()
local scrollable = the_playlist:scrollable();
local shown_before = w3_scrollbar.show;
if (scrollable) then
w3_scrollbar.show = true;
w3_scrollbar.enabled = true;
else
w3_scrollbar.show = false;
w3_scrollbar.enabled = false;
end
if (scrollable ~= shown_before) then
w3_scrollbar:redraw();
end
end
the_scrollbar_image = image.new (skin_bitmap, rect.new_size (29, 18, 17, 24));
the_scrollbar_place = rect.new (-17, 18, 0, -18);
w3_scrollbar = progbar.new (the_scrollbar_place, the_scrollbar_image, 100, nil,
function() the_playlist:set_pos (w3_scrollbar.pos); end,
w3_check_scrollable
);
win_playlist:add (w3_scrollbar);
resizer_image = image.new (skin_bitmap, rect.new_size (28, 42, 18, 18));
p3_size_sw = rect.new (0, -18, 18, 0);
p3_size_se = rect.new (-18, -18, 0, 0);
p3_size_s = rect.new (18, -18, -18, 0);
p3_size_w = rect.new (0, 18, 18, -18);
p3_size_e = rect.new (-18, 18, 0, -18);
win_playlist:add (p3_size_se);
win_playlist:add (p3_size_sw);
win_playlist:add (p3_size_s);
win_playlist:add (p3_size_w);
win_playlist:add (p3_size_e);
win_playlist:add_part_callback ("LDown", p3_size_se, function () win_playlist:resize (7); end);
win_playlist:add_part_callback ("LDown", p3_size_sw, function () win_playlist:resize (6); end);
win_playlist:add_part_callback ("LDown", p3_size_s, function () win_playlist:resize (5); end);
win_playlist:add_part_callback ("LDown", p3_size_w, function () win_playlist:resize (0); end);
win_playlist:add_part_callback ("LDown", p3_size_e, function () win_playlist:resize (1); end);
p3_size_grip = rect.new (-18, -18, 0, 0);
win_playlist:add_paint_part (p3_size_grip, resizer_image);
win_playlist:add_part_callback ("RDown", p_all,
function ()
local x = window.get_mouse_pos ().x - win_playlist:get_pos ().left;
local y = window.get_mouse_pos ().y - win_playlist:get_pos ().top;
r_pressed = true;
r_press_pos_x = x;
r_press_pos_y = y;
end );                       
win_playlist:add_part_callback ("RUp", p_all,
function ()
r_pressed = false;
if (not rotated) then
local x = window.get_mouse_pos ().x - win_playlist:get_pos ().left;
local y = window.get_mouse_pos ().y - win_playlist:get_pos ().top;
r_motion_x = x - r_press_pos_x;
r_motion_y = y - r_press_pos_y;
r_motion = math.sqrt (r_motion_x*r_motion_x + r_motion_y*r_motion_y);
gesture = o_gestures and (r_motion > gesture_insensitivity);
gesture_left = (r_motion_x < 0) and (math.abs (r_motion_x) > math.abs (r_motion_y) * gesture_angle_parameter);
gesture_right = (r_motion_x > 0) and (math.abs (r_motion_x) > math.abs (r_motion_y) * gesture_angle_parameter);
gesture_up = (r_motion_y < 0) and (math.abs (r_motion_y) > math.abs (r_motion_x) * gesture_angle_parameter);
gesture_down = (r_motion_y > 0) and (math.abs (r_motion_y) > math.abs (r_motion_x) * gesture_angle_parameter);
if gesture and gesture_right then next_track ()
elseif gesture and gesture_left then prev_track ()
elseif gesture and gesture_up then playlist_showhide ();
elseif gesture and gesture_down then playlist_showhide ();
else foobar.show_main_menu ();
end
end
rotated = false;
r_press_pos = 0;
end
);
win_playlist:set_callback ("OnSizeEnd", w3_check_scrollable);
win_playlist:set_callback ("OnWheelDown", function ()
the_playlist:scroll(playlist_scroll_step);
w3_check_scrollable ();
end );
win_playlist:set_callback ("OnWheelUp", function ()
the_playlist:scroll (-playlist_scroll_step);
w3_check_scrollable ();
end );
set_global_callback ("OnDynamic",
function ()
the_playlist:redraw ();
end
);
paused_flip = false;
paused_timer = timer.new (
function ()
if (paused_flip or slider.sliding) then
title_field:set_draw_mode (-1);
time_field:set_draw_mode (-1);
else
title_field:set_draw_mode (paused_blink_opacity);
time_field:set_draw_mode (paused_blink_opacity);
end
title_field:update ();
time_field:update ();
paused_flip = not paused_flip;
end
)
function check_pausedness ()
paused = foobar.is_playing () == 2;
if paused then
if display_paused then 
time_field:set_text ('Paused');
update_textfield_sizes ()
end
paused_flip = false;
if paused_blink then
paused_timer:start (paused_blink_delay);
else
temp_display_timer:start (temp_display_delay);
end
else
title_field:set_draw_mode (-1);
time_field:set_draw_mode (-1);
title_field:set_text (title_format);
if display_playing then
time_field:set_text ('Playing');
temp_display_timer:start (temp_display_delay);
else
time_field:set_text (time_format);
end 
update_textfield_sizes ()
if paused_blink then
paused_timer:stop ();
end
end
end
set_global_callback ("OnPause", check_pausedness);
set_global_callback ("OnPlaylistCountChanged", w3_check_scrollable);
set_global_callback ("OnOrderChange",
function ()
time_field:set_text (foobar.get_order ());
update_textfield_sizes ()
temp_display_timer:start (temp_display_delay);
end
);
set_global_callback ("OnStop",
function ()
slider.show = false;
slider.enabled = false;
slider:redraw ();
if (win_stripe:is_visible ()) then
w1_newTrack ();
end
end
);
set_global_callback ("OnStart",
function ()
slider.show = true;
slider.enabled = true;
slider:redraw ();
check_pausedness ();
end
);
set_global_callback ("OnVolumeChange", 
function ()
if (foobar.get_volume () == -100)
then time_field:set_text ('Mute');
else time_field:set_text ('Volume: ' .. string.format ("%i", 100 + foobar.get_volume ()) .. "'%'");
end
update_textfield_sizes ()
temp_display_timer:start (temp_display_delay);
end
);
docking.set_snap_gap (snap_gap);
docking.add_window (win_stripe);
docking.add_window (win_playlist);
if (config.load_windows () ~= true) then
win_stripe:create ();
end
if (foobar.is_playing () ~= 0) then
slider.show = true;
slider.enabled = true;
slider:redraw ();
check_pausedness ();
end
add_tray_icon ("birman.ico", 0, 
function () foobar.run_menu_command ("Activate or hide"); end,
function () foobar.show_main_menu ("System"); end
);
set_global_callback ("OnUnload",
function () remove_tray_icon (0); end
);
